/*
 * data_handling.h
 *
 * Created: 4/20/2012 12:03:11 PM
 *  Author: Doug
 */ 


#ifndef DATA_HANDLING_H_
#define DATA_HANDLING_H_

#define NO_ZERO
#ifdef NO_ZERO
//#define STEREO
#endif //NO_ZERO

#include "avr_compiler.h"

// 33868800MHZ gives you 768 samples per period for 44.1kHz
#ifdef STEREO
#define TIMER_CD0_PERIOD 1536-1 //22050Hz
#else
#define TIMER_CD0_PERIOD 768-1	//44100Hz
#endif


#define DMA_NUM_BURSTS_IN_BLOCK 128

#define DMA_RX_Channel &DMA.CH1

#define DMA_RX_BUFFER_LEN 64


//Function Declarations
void copy_int_to_right_channel(uint16_t * data);
void copy_int_to_left_channel(uint16_t * data);
uint16_t bytes_in_left_audio_buffer(void);
int8_t copy_8bit_mono_to_buffer(uint8_t * data, uint16_t len);
void play_both_channels(void);
void play_left_channel(void);
void play_right_channel(void);
void send_data_to_DMA(void);
void SetupReceiveChannel( void );
int8_t copy_8bit_mono_to_buffer_no_zero(uint8_t * data, uint16_t len);
int8_t copy_8bit_stereo_to_buffer_no_zero(uint8_t * data, uint16_t len);
void dma_setup_right_no_zero( const void * src, int16_t blockSize);
void dma_setup_left_no_zero( const void * src, int16_t blockSize );
extern volatile uint8_t dma_rx_buffer_number;
extern volatile uint8_t dma_rx_buffer_ready;

extern uint8_t dma_rx_buffer0[DMA_RX_BUFFER_LEN];
extern uint8_t dma_rx_buffer1[DMA_RX_BUFFER_LEN];
extern uint8_t dma_rx_buffer2[DMA_RX_BUFFER_LEN];

#endif /* DATA_HANDLING_H_ */